Index: vendors/IOIPSL/current/src/histcom.f90
===================================================================
--- vendors/IOIPSL/current/src/histcom.f90	(revision 1989)
+++ vendors/IOIPSL/current/src/histcom.f90	(revision 1991)
@@ -1,5 +1,5 @@
 MODULE histcom
 !-
-!$Id: histcom.f90 740 2009-09-17 08:26:28Z bellier $
+!$Id: histcom.f90 1028 2010-05-20 15:17:30Z bellier $
 !-
 ! This software is governed by the CeCILL license
@@ -35,4 +35,13 @@
 !- to describe the grid, just two vectors.
 !---------------------------------------------------------------------
+!-
+  INTERFACE histbeg
+    MODULE PROCEDURE histb_reg1d,histb_reg2d,histb_irreg
+  END INTERFACE
+!-
+  INTERFACE histhori
+    MODULE PROCEDURE histh_reg1d,histh_reg2d,histh_irreg
+  END INTERFACE
+!-
   INTERFACE histwrite
 !---------------------------------------------------------------------
@@ -46,5 +55,5 @@
 !-
 !- INPUT
-!- pfileid  : The ID of the file on which this variable is to be,
+!- idf      : The ID of the file on which this variable is to be,
 !-            written. The variable should have been defined in
 !-            this file before.
@@ -63,12 +72,4 @@
   END INTERFACE
 !-
-  INTERFACE histbeg
-    MODULE PROCEDURE histbeg_totreg,histbeg_regular,histbeg_irregular
-  END INTERFACE
-!-
-  INTERFACE histhori
-    MODULE PROCEDURE histhori_regular,histhori_irregular
-  END INTERFACE
-!-
 ! Fixed parameter
 !-
@@ -76,84 +77,73 @@
  &                     nb_hax_max=5,nb_zax_max=10,nbopp_max=10
   REAL,PARAMETER :: missing_val=nf90_fill_real
-!-
-  INTEGER :: bufftmp_max(nb_files_max) = 1
-!-
-! Time variables
-!-
-  INTEGER,SAVE :: itau0(nb_files_max)=0
-  REAL,DIMENSION(nb_files_max),SAVE ::date0,deltat
-!-
-! Counter of elements
-!-
-  INTEGER,SAVE :: nb_files=0
-  INTEGER,DIMENSION(nb_files_max),SAVE :: nb_var=0,nb_tax=0
-!-
-! DOMAIN IDs for files
-!-
-  INTEGER,DIMENSION(nb_files_max),SAVE :: dom_id_svg=-1
-!-
-! NETCDF IDs for files and axes
-!-
-  INTEGER,DIMENSION(nb_files_max),SAVE :: ncdf_ids,xid,yid,tid
-!-
-! General definitions in the NETCDF file
-!-
-  INTEGER,DIMENSION(nb_files_max,2),SAVE :: &
- &   full_size=0,slab_ori,slab_sz
-!-
-! The horizontal axes
-!-
-  INTEGER,SAVE :: nb_hax(nb_files_max)=0
-  CHARACTER(LEN=25),SAVE :: hax_name(nb_files_max,nb_hax_max,2)
-!-
-! The vertical axes
-!-
-  INTEGER,SAVE :: nb_zax(nb_files_max)=0
-  INTEGER,DIMENSION(nb_files_max,nb_zax_max),SAVE :: &
-  &  zax_size,zax_ids
-  CHARACTER(LEN=20),SAVE :: zax_name(nb_files_max,nb_zax_max)
-!-
-! Informations on each variable
-!-
-  INTEGER,DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  nbopp
-  CHARACTER(LEN=20),DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  name,unit_name
-  CHARACTER(LEN=80),DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  title,fullop
-  CHARACTER(LEN=7),SAVE :: topp(nb_files_max,nb_var_max)
-  CHARACTER(LEN=7),SAVE :: sopps(nb_files_max,nb_var_max,nbopp_max)
-  REAL,SAVE :: scal(nb_files_max,nb_var_max,nbopp_max)
-!- Sizes of the associated grid and zommed area
-  INTEGER,DIMENSION(nb_files_max,nb_var_max,3),SAVE :: &
- &   scsize,zorig,zsize
-!- Sizes for the data as it goes through the various math operations
-  INTEGER,SAVE :: datasz_in(nb_files_max,nb_var_max,3) = -1
-  INTEGER,SAVE :: datasz_max(nb_files_max,nb_var_max) = -1
-!-
-  INTEGER,DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  var_haxid,var_zaxid,var_axid,ncvar_ids
-!-
-  REAL,DIMENSION(nb_files_max,nb_var_max,2),SAVE :: hist_minmax
-  LOGICAL,DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  hist_calc_rng=.FALSE.,hist_wrt_rng=.FALSE.
-!-
-  REAL,DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  freq_opp,freq_wrt
-  INTEGER,DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  last_opp,last_wrt,last_opp_chk,last_wrt_chk,nb_opp,nb_wrt,point
-!-
-! Book keeping for the buffers
-!-
-  INTEGER,SAVE :: buff_pos=0
-  REAL,ALLOCATABLE,DIMENSION(:),SAVE :: buffer
-  LOGICAL,DIMENSION(nb_files_max),SAVE :: zoom=.FALSE.,regular=.TRUE.
-!-
-! Book keeping of the axes
-!-
-  INTEGER,DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  tdimid,tax_last
-  CHARACTER(LEN=40),DIMENSION(nb_files_max,nb_var_max),SAVE :: &
- &  tax_name
+  INTEGER,PARAMETER,PUBLIC :: &
+ &  hist_r4=nf90_real4, hist_r8=nf90_real8
+!-
+! Variable derived type
+!-
+TYPE T_D_V
+  INTEGER :: ncvid
+  INTEGER :: nbopp
+  CHARACTER(LEN=20)  :: v_name,unit_name
+  CHARACTER(LEN=256) :: title,std_name
+  CHARACTER(LEN=80)  :: fullop
+  CHARACTER(LEN=7)   :: topp
+  CHARACTER(LEN=7),DIMENSION(nbopp_max) :: sopp
+  REAL,DIMENSION(nbopp_max) :: scal
+!-External type (for R4/R8)
+  INTEGER :: v_typ
+!-Sizes of the associated grid and zommed area
+  INTEGER,DIMENSION(3) :: scsize,zorig,zsize
+!-Sizes for the data as it goes through the various math operations
+  INTEGER,DIMENSION(3) :: datasz_in = -1
+  INTEGER :: datasz_max = -1
+!-
+  INTEGER :: h_axid,z_axid,t_axid
+!-
+  REAL,DIMENSION(2) :: hist_minmax
+  LOGICAL :: hist_calc_rng=.FALSE.,hist_wrt_rng=.FALSE.
+!-Book keeping of the axes
+  INTEGER :: tdimid,tbndid=-1,tax_last
+  LOGICAL :: l_bnd
+  CHARACTER(LEN=40) :: tax_name
+!-
+  REAL :: freq_opp,freq_wrt
+  INTEGER :: &
+ &  last_opp,last_wrt,last_opp_chk,last_wrt_chk,nb_opp,nb_wrt
+!- For future optimization
+  REAL,POINTER,DIMENSION(:) :: t_bf
+!#  REAL,ALLOCATABLE,DIMENSION(:) :: V_1_D
+!#  REAL,ALLOCATABLE,DIMENSION(:,:) :: V_2_D
+!#  REAL,ALLOCATABLE,DIMENSION(:,:,:) :: V_3_D
+END TYPE T_D_V
+!-
+! File derived type
+!-
+TYPE :: T_D_F
+!-NETCDF IDs for file
+  INTEGER :: ncfid=-1
+!-Time variables
+  INTEGER :: itau0=0
+  REAL :: date0,deltat
+!-Counter of elements (variables, time-horizontal-vertical axis
+  INTEGER :: n_var=0,n_tax=0,n_hax=0,n_zax=0
+!-NETCDF dimension IDs for time-[time_bounds]-longitude-latitude
+  INTEGER :: tid,bid,xid,yid
+!-General definitions in the NETCDF file
+  INTEGER,DIMENSION(2) :: full_size=0,slab_ori,slab_siz
+!-The horizontal axes
+  CHARACTER(LEN=25),DIMENSION(nb_hax_max,2) :: hax_name
+!-The vertical axes
+  INTEGER,DIMENSION(nb_zax_max) :: zax_size,zax_ids
+  CHARACTER(LEN=20),DIMENSION(nb_zax_max) :: zax_name
+!-
+  LOGICAL :: regular=.TRUE.
+!-DOMAIN ID
+  INTEGER :: dom_id_svg=-1
+!-
+  TYPE(T_D_V),DIMENSION(nb_var_max) :: W_V
+END TYPE T_D_F
+!-
+TYPE(T_D_F),DIMENSION(nb_files_max),SAVE :: W_F
 !-
 ! A list of functions which require special action
@@ -161,7 +151,5 @@
 !  but they are well located here)
 !-
-  CHARACTER(LEN=120),SAVE :: &
- &  indchfun = 'scatter, fill, gather, coll', &
- &  fuchnbout = 'scatter, fill'
+  CHARACTER(LEN=30),SAVE :: fuchnbout = 'scatter, fill'
 !- Some configurable variables with locks
   CHARACTER(LEN=80),SAVE :: model_name='An IPSL model'
@@ -172,55 +160,10 @@
 !===
 !-
-SUBROUTINE histbeg_totreg                 &
- & (pfilename,pim,plon,pjm,plat,          &
- &  par_orix,par_szx,par_oriy,par_szy,    &
- &  pitau0,pdate0,pdeltat,phoriid,pfileid,domain_id)
-!---------------------------------------------------------------------
-!- This is just an interface for histbeg_regular in case when
-!- the user provides plon and plat as vectors.
-!- Obviously this can only be used for very regular grids.
-!-
-!- INPUT
-!-
-!- pfilename : Name of the netcdf file to be created
-!- pim       : Size of arrays in longitude direction
-!- plon      : Coordinates of points in longitude
-!- pjm       : Size of arrays in latitude direction
-!- plat      : Coordinates of points in latitude
-!-
-!- The next 4 arguments allow to define a horizontal zoom
-!- for this file. It is assumed that all variables to come
-!- have the same index space. This can not be assumed for
-!- the z axis and thus we define the zoom in histdef.
-!-
-!- par_orix  : Origin of the slab of data within the X axis (pim)
-!- par_szx   : Size of the slab of data in X
-!- par_oriy  : Origin of the slab of data within the Y axis (pjm)
-!- par_szy   : Size of the slab of data in Y
-!-
-!- pitau0    : time step at which the history tape starts
-!- pdate0    : The Julian date at which the itau was equal to 0
-!- pdeltat   : Time step in seconds. Time step of the counter itau
-!-             used in histwrite for instance
-!-
-!- OUTPUT
-!-
-!- phoriid   : ID of the horizontal grid
-!- pfileid   : ID of the netcdf file
-!-
-!- Optional INPUT arguments
-!-
-!- domain_id       : Domain identifier
-!-
-!- TO DO
-!-
-!- This package should be written in f90
-!- and use the following features :
-!-    - structures for the meta-data of the files and variables
-!-    - memory allocation as needed
-!-    - Pointers
-!-
-!- VERSION
-!-
+SUBROUTINE histb_reg1d                 &
+ & (pfilename,pim,plon,pjm,plat,       &
+ &  par_orix,par_szx,par_oriy,par_szy, &
+ &  pitau0,pdate0,pdeltat,phoriid,idf,domain_id,mode)
+!---------------------------------------------------------------------
+!- histbeg for 1D regular horizontal coordinates (see histb_all)
 !---------------------------------------------------------------------
   IMPLICIT NONE
@@ -233,83 +176,22 @@
   INTEGER,INTENT(IN) :: pitau0
   REAL,INTENT(IN) :: pdate0,pdeltat
-  INTEGER,INTENT(OUT) :: pfileid,phoriid
+  INTEGER,INTENT(OUT) :: idf,phoriid
   INTEGER,INTENT(IN),OPTIONAL :: domain_id
-!-
-  REAL,ALLOCATABLE,DIMENSION(:,:) :: lon_tmp,lat_tmp
-  LOGICAL :: l_dbg
-!---------------------------------------------------------------------
-  CALL ipsldbg (old_status=l_dbg)
-!-
-  IF (l_dbg) WRITE(*,*) "histbeg_totreg"
-!-
-  ALLOCATE(lon_tmp(pim,pjm),lat_tmp(pim,pjm))
-!-
-  lon_tmp(:,:) = SPREAD(plon(:),2,pjm)
-  lat_tmp(:,:) = SPREAD(plat(:),1,pim)
-!-
-  CALL histbeg_regular &
- &  (pfilename,pim,lon_tmp,pjm,lat_tmp, &
- &   par_orix,par_szx,par_oriy,par_szy, &
- &   pitau0,pdate0,pdeltat,phoriid,pfileid, &
- &   .TRUE.,domain_id)
-!-
-  DEALLOCATE(lon_tmp,lat_tmp)
-!----------------------------
-END SUBROUTINE histbeg_totreg
+  CHARACTER(LEN=*),OPTIONAL,INTENT(IN) :: mode
+!---------------------------------------------------------------------
+  CALL histb_all &
+ & (1,pfilename,pim,pjm,pitau0,pdate0,pdeltat,phoriid,idf, &
+ &  x_1d=plon,y_1d=plat, &
+ &  k_orx=par_orix,k_szx=par_szx,k_ory=par_oriy,k_szy=par_szy, &
+ &  domain_id=domain_id,mode=mode)
+!-------------------------
+END SUBROUTINE histb_reg1d
 !===
-SUBROUTINE histbeg_regular &
- & (pfilename,pim,plon,pjm,plat,           &
- &  par_orix,par_szx,par_oriy,par_szy,     &
- &  pitau0,pdate0,pdeltat,phoriid,pfileid, &
- &  opt_rectilinear,domain_id)
-!---------------------------------------------------------------------
-!- This subroutine initializes a netcdf file and returns the ID.
-!- It will set up the geographical space on which the data will be
-!- stored and offers the possibility of seting a zoom.
-!- It also gets the global parameters into the I/O subsystem.
-!-
-!- INPUT
-!-
-!- pfilename : Name of the netcdf file to be created
-!- pim       : Size of arrays in longitude direction
-!- plon      : Coordinates of points in longitude
-!- pjm       : Size of arrays in latitude direction
-!- plat      : Coordinates of points in latitude
-!-
-!- The next 4 arguments allow to define a horizontal zoom
-!- for this file. It is assumed that all variables to come
-!- have the same index space. This can not be assumed for
-!- the z axis and thus we define the zoom in histdef.
-!-
-!- par_orix  : Origin of the slab of data within the X axis (pim)
-!- par_szx   : Size of the slab of data in X
-!- par_oriy  : Origin of the slab of data within the Y axis (pjm)
-!- par_szy   : Size of the slab of data in Y
-!-
-!- pitau0    : time step at which the history tape starts
-!- pdate0    : The Julian date at which the itau was equal to 0
-!- pdeltat   : Time step in seconds. Time step of the counter itau
-!-             used in histwrite for instance
-!-
-!- OUTPUT
-!-
-!- phoriid   : ID of the horizontal grid
-!- pfileid   : ID of the netcdf file
-!-
-!- Optional INPUT arguments
-!-
-!- opt_rectilinear : If true we know the grid is rectilinear
-!- domain_id       : Domain identifier
-!-
-!- TO DO
-!-
-!- This package should be written in F90 and use the following
-!- feature :
-!-   - structures for the meta-data of the files and variables
-!-   - memory allocation as needed
-!-   - Pointers
-!-
-!- VERSION
-!-
+SUBROUTINE histb_reg2d &
+ & (pfilename,pim,plon,pjm,plat,       &
+ &  par_orix,par_szx,par_oriy,par_szy, &
+ &  pitau0,pdate0,pdeltat,phoriid,idf,domain_id,mode)
+!---------------------------------------------------------------------
+!- histbeg for 2D regular horizontal coordinates (see histb_all)
 !---------------------------------------------------------------------
   IMPLICIT NONE
@@ -321,146 +203,21 @@
   INTEGER,INTENT(IN) :: pitau0
   REAL,INTENT(IN) :: pdate0,pdeltat
-  INTEGER,INTENT(OUT) :: pfileid,phoriid
-  LOGICAL,INTENT(IN),OPTIONAL :: opt_rectilinear
+  INTEGER,INTENT(OUT) :: idf,phoriid
   INTEGER,INTENT(IN),OPTIONAL :: domain_id
-!-
-  INTEGER :: ncid,iret
-  CHARACTER(LEN=120) :: file
-  CHARACTER(LEN=30) :: timenow
-  LOGICAL :: rectilinear
-  LOGICAL :: l_dbg
-!---------------------------------------------------------------------
-  CALL ipsldbg (old_status=l_dbg)
-!-
-  nb_files = nb_files+1
-  pfileid  = nb_files
-!-
-! 1.0 Transfering into the common for future use
-!-
-  IF (l_dbg) WRITE(*,*) "histbeg_regular 1.0"
-!-
-  itau0(pfileid) = pitau0
-  date0(pfileid) = pdate0
-  deltat(pfileid) = pdeltat
-!-
-  IF (PRESENT(opt_rectilinear)) THEN
-    rectilinear = opt_rectilinear
-  ELSE
-    rectilinear = .FALSE.
-  ENDIF
-!-
-! 2.0 Initializes all variables for this file
-!-
-  IF (l_dbg) WRITE(*,*) "histbeg_regular 2.0"
-!-
-  IF (nb_files > nb_files_max) THEN
-    CALL ipslerr (3,"histbeg", &
-   &  'Table of files too small. You should increase nb_files_max', &
-   &  'in histcom.f90 in order to accomodate all these files',' ')
-  ENDIF
-!-
-  nb_var(pfileid) = 0
-  nb_tax(pfileid) = 0
-  nb_hax(pfileid) = 0
-  nb_zax(pfileid) = 0
-!-
-  slab_ori(pfileid,1:2) = (/ par_orix,par_oriy /)
-  slab_sz(pfileid,1:2)  = (/ par_szx, par_szy  /)
-!-
-! 3.0 Opening netcdf file and defining dimensions
-!-
-  IF (l_dbg) WRITE(*,*) "histbeg_regular 3.0"
-!-
-! Add DOMAIN number and ".nc" suffix in file name if needed
-!-
-  file = pfilename
-  CALL flio_dom_file (file,domain_id)
-!-
-  iret = NF90_CREATE (file,NF90_CLOBBER,ncid)
-!-
-  IF (rectilinear) THEN
-    iret = NF90_DEF_DIM (ncid,'lon',par_szx,xid(nb_files))
-    iret = NF90_DEF_DIM (ncid,'lat',par_szy,yid(nb_files))
-  ELSE
-    iret = NF90_DEF_DIM (ncid,'x',par_szx,xid(nb_files))
-    iret = NF90_DEF_DIM (ncid,'y',par_szy,yid(nb_files))
-  ENDIF
-!-
-! 4.0 Declaring the geographical coordinates and other attributes
-!-
-  IF (l_dbg) WRITE(*,*) "histbeg_regular 4.0"
-!-
-! 4.3 Global attributes
-!-
-  iret = NF90_PUT_ATT (ncid,NF90_GLOBAL,'Conventions','CF-1.1')
-  iret = NF90_PUT_ATT (ncid,NF90_GLOBAL,'file_name',TRIM(file))
-  iret = NF90_PUT_ATT (ncid,NF90_GLOBAL,'production',TRIM(model_name))
-  lock_modname = .TRUE.
-  CALL ioget_timestamp (timenow)
-  iret = NF90_PUT_ATT (ncid,NF90_GLOBAL,'TimeStamp',TRIM(timenow))
-!-
-! 5.0 Saving some important information on this file in the common
-!-
-  IF (l_dbg) WRITE(*,*) "histbeg_regular 5.0"
-!-
-  IF (PRESENT(domain_id)) THEN
-    dom_id_svg(pfileid) = domain_id
-  ENDIF
-  ncdf_ids(pfileid) = ncid
-  full_size(pfileid,1:2) = (/ pim,pjm /)
-!-
-! 6.0 storing the geographical coordinates
-!-
-  zoom(pfileid) = (pim /= par_szx).OR.(pjm /= par_szy)
-  regular(pfileid)=.TRUE.
-!-
-  CALL histhori_regular (pfileid,pim,plon,pjm,plat, &
- &  ' ' ,'Default grid',phoriid,rectilinear)
-!-----------------------------
-END SUBROUTINE histbeg_regular
+  CHARACTER(LEN=*),OPTIONAL,INTENT(IN) :: mode
+!---------------------------------------------------------------------
+  CALL histb_all &
+ & (2,pfilename,pim,pjm,pitau0,pdate0,pdeltat,phoriid,idf,  &
+ &  x_2d=plon,y_2d=plat, &
+ &  k_orx=par_orix,k_szx=par_szx,k_ory=par_oriy,k_szy=par_szy,    &
+ &  domain_id=domain_id,mode=mode)
+!-------------------------
+END SUBROUTINE histb_reg2d
 !===
-SUBROUTINE histbeg_irregular &
- &  (pfilename,pim,plon,plon_bounds,plat,plat_bounds,   &
- &   pitau0,pdate0,pdeltat,phoriid,pfileid,domain_id)
-!---------------------------------------------------------------------
-!- This subroutine initializes a netcdf file and returns the ID.
-!- This version is for totaly irregular grids. In this case all
-!- all the data comes in as vectors and for the grid we have
-!- the coordinates of the 4 corners.
-!- It also gets the global parameters into the I/O subsystem.
-!-
-!- INPUT
-!-
-!- pfilename   : Name of the netcdf file to be created
-!- pim         : Size of arrays in longitude direction
-!- plon        : Coordinates of points in longitude
-!- plon_bounds : The 2 corners of the grid in longitude
-!- plat        : Coordinates of points in latitude
-!- plat_bounds : The 2 corners of the grid in latitude
-!-
-!- pitau0    : time step at which the history tape starts
-!- pdate0    : The Julian date at which the itau was equal to 0
-!- pdeltat   : Time step in seconds. Time step of the counter itau
-!-             used in histwrite for instance
-!-
-!- OUTPUT
-!-
-!- phoriid   : ID of the horizontal grid
-!- pfileid   : ID of the netcdf file
-!-
-!- Optional INPUT arguments
-!-
-!- domain_id       : Domain identifier
-!-
-!- TO DO
-!-
-!- This package should be written in F90 and use the following
-!- feature :
-!-   - structures for the meta-data of the files and variables
-!-   - memory allocation as needed
-!-   - Pointers
-!-
-!- VERSION
-!-
+SUBROUTINE histb_irreg &
+ &  (pfilename,pim,plon,plon_bounds,plat,plat_bounds, &
+ &   pitau0,pdate0,pdeltat,phoriid,idf,domain_id,mode)
+!---------------------------------------------------------------------
+!- histbeg for irregular horizontal coordinates (see histb_all)
 !---------------------------------------------------------------------
   IMPLICIT NONE
@@ -472,30 +229,126 @@
   INTEGER,INTENT(IN) :: pitau0
   REAL,INTENT(IN) :: pdate0,pdeltat
-  INTEGER,INTENT(OUT) :: pfileid,phoriid
+  INTEGER,INTENT(OUT) :: idf,phoriid
   INTEGER,INTENT(IN),OPTIONAL :: domain_id
-!-
-  INTEGER :: ncid,iret
+  CHARACTER(LEN=*),OPTIONAL,INTENT(IN) :: mode
+!---------------------------------------------------------------------
+  CALL histb_all &
+ & (3,pfilename,pim,pim,pitau0,pdate0,pdeltat,phoriid,idf,  &
+ &  x_1d=plon,y_1d=plat,x_bnds=plon_bounds,y_bnds=plat_bounds, &
+ &  domain_id=domain_id,mode=mode)
+!-------------------------
+END SUBROUTINE histb_irreg
+!===
+SUBROUTINE histb_all &
+ & (k_typ,nc_name,pim,pjm,pitau0,pdate0,pdeltat,phoriid,idf, &
+ &  x_1d,y_1d,x_2d,y_2d,k_orx,k_szx,k_ory,k_szy, &
+ &  x_bnds,y_bnds,domain_id,mode)
+!---------------------------------------------------------------------
+!- General interface for horizontal grids.
+!- This subroutine initializes a netcdf file and returns the ID.
+!- It will set up the geographical space on which the data will be
+!- stored and offers the possibility of seting a zoom.
+!- In the case of irregular grids, all the data comes in as vectors
+!- and for the grid we have the coordinates of the 4 corners.
+!- It also gets the global parameters into the I/O subsystem.
+!-
+!- INPUT
+!-
+!- k_typ    : Type of the grid (1 rectilinear, 2 regular, 3 irregular)
+!- nc_name  : Name of the netcdf file to be created
+!- pim      : Size of arrays in longitude direction
+!- pjm      : Size of arrays in latitude direction (pjm=pim for type 3)
+!-
+!- pitau0   : time step at which the history tape starts
+!- pdate0   : The Julian date at which the itau was equal to 0
+!- pdeltat  : Time step, in seconds, of the counter itau
+!-            used in histwrite for instance
+!-
+!- OUTPUT
+!-
+!- phoriid  : Identifier of the horizontal grid
+!- idf      : Identifier of the file
+!-
+!- Optional INPUT arguments
+!-
+!- For rectilinear or irregular grid
+!- x_1d  : The longitudes
+!- y_1d  : The latitudes
+!- For regular grid
+!- x_2d  : The longitudes
+!- y_2d  : The latitudes
+!- One pair (x_1d,y_1d) or (x_2d,y_2d) must be supplied.
+!-
+!- For regular grid (reg1d or reg2d),
+!- the next 4 arguments allow to define a horizontal zoom
+!- for this file. It is assumed that all variables to come
+!- have the same index space. This can not be assumed for
+!- the z axis and thus we define the zoom in histdef.
+!- k_orx  : Origin of the slab of data within the X axis (pim)
+!- k_szx  : Size of the slab of data in X
+!- k_ory  : Origin of the slab of data within the Y axis (pjm)
+!- k_szy  : Size of the slab of data in Y
+!-
+!- For irregular grid.
+!- x_bnds : The boundaries of the grid in longitude
+!- y_bnds : The boundaries of the grid in latitude
+!-
+!- For all grids.
+!-
+!- domain_id  : Domain identifier
+!-
+!- mode       : String of (case insensitive) blank-separated words
+!-              defining the mode used to create the file.
+!-              Supported keywords : 32, 64
+!-              "32/64" defines the offset mode.
+!-              The default offset mode is 64 bits.
+!-              Keywords "NETCDF4" and "CLASSIC" are reserved
+!-              for future use.
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  INTEGER,INTENT(IN) :: k_typ
+  CHARACTER(LEN=*),INTENT(IN) :: nc_name
+  INTEGER,INTENT(IN) :: pim,pjm
+  INTEGER,INTENT(IN) :: pitau0
+  REAL,INTENT(IN) :: pdate0,pdeltat
+  INTEGER,INTENT(OUT) :: idf,phoriid
+  REAL,DIMENSION(:),INTENT(IN),OPTIONAL :: x_1d,y_1d
+  REAL,DIMENSION(:,:),INTENT(IN),OPTIONAL :: x_2d,y_2d
+  INTEGER,INTENT(IN),OPTIONAL :: k_orx,k_szx,k_ory,k_szy
+  REAL,DIMENSION(:,:),INTENT(IN),OPTIONAL :: x_bnds,y_bnds
+  INTEGER,INTENT(IN),OPTIONAL :: domain_id
+  CHARACTER(LEN=*),OPTIONAL,INTENT(IN) :: mode
+!-
+  INTEGER :: nfid,iret,m_c
   CHARACTER(LEN=120) :: file
   CHARACTER(LEN=30) :: timenow
+  CHARACTER(LEN=11) :: c_nam
   LOGICAL :: l_dbg
 !---------------------------------------------------------------------
   CALL ipsldbg (old_status=l_dbg)
 !-
-  nb_files = nb_files+1
-  pfileid  = nb_files
-!-
-! 1.0 Transfering into the common for future use
-!-
-  IF (l_dbg) WRITE(*,*) "histbeg_irregular 1.0"
-!-
-  itau0(pfileid) = pitau0
-  date0(pfileid) = pdate0
-  deltat(pfileid) = pdeltat
-!-
-! 2.0 Initializes all variables for this file
-!-
-  IF (l_dbg) WRITE(*,*) "histbeg_irregular 2.0"
-!-
-  IF (nb_files > nb_files_max) THEN
+  IF     (k_typ == 1) THEN
+    c_nam = 'histb_reg1d'
+  ELSEIF (k_typ == 2) THEN
+    c_nam = 'histb_reg2d'
+  ELSEIF (k_typ == 3) THEN
+    c_nam = 'histb_irreg'
+  ELSE
+    CALL ipslerr (3,"histbeg", &
+ &    'Illegal value of k_typ argument','in internal interface','?')
+  ENDIF
+!-
+  IF (l_dbg) WRITE(*,*) c_nam//" 0.0"
+!-
+! Search for a free index
+!-
+  idf = -1
+  DO nfid=1,nb_files_max
+    IF (W_F(nfid)%ncfid < 0) THEN
+      idf = nfid; EXIT;
+    ENDIF
+  ENDDO
+  IF (idf < 0) THEN
     CALL ipslerr (3,"histbeg", &
    &  'Table of files too small. You should increase nb_files_max', &
@@ -503,64 +356,175 @@
   ENDIF
 !-
-  nb_var(pfileid) = 0
-  nb_tax(pfileid) = 0
-  nb_hax(pfileid) = 0
-  nb_zax(pfileid) = 0
-!-
-  slab_ori(pfileid,1:2) = (/ 1,1 /)
-  slab_sz(pfileid,1:2)  = (/ pim,1 /)
+! 1.0 Transfering into the common for future use
+!-
+  IF (l_dbg) WRITE(*,*) c_nam//" 1.0"
+!-
+  W_F(idf)%itau0  = pitau0
+  W_F(idf)%date0  = pdate0
+  W_F(idf)%deltat = pdeltat
+!-
+! 2.0 Initializes all variables for this file
+!-
+  IF (l_dbg) WRITE(*,*) c_nam//" 2.0"
+!-
+  W_F(idf)%n_var = 0
+  W_F(idf)%n_tax = 0
+  W_F(idf)%n_hax = 0
+  W_F(idf)%n_zax = 0
+!-
+  IF ( (k_typ == 1).OR.(k_typ == 2) ) THEN
+    W_F(idf)%slab_ori(1:2) = (/ k_orx,k_ory /)
+    W_F(idf)%slab_siz(1:2)  = (/ k_szx,k_szy /)
+  ELSE
+    W_F(idf)%slab_ori(1:2) = (/ 1,1 /)
+    W_F(idf)%slab_siz(1:2) = (/ pim,1 /)
+  ENDIF
 !-
 ! 3.0 Opening netcdf file and defining dimensions
 !-
-  IF (l_dbg) WRITE(*,*) "histbeg_irregular 3.0"
+  IF (l_dbg) WRITE(*,*) c_nam//" 3.0"
 !-
 ! Add DOMAIN number and ".nc" suffix in file name if needed
 !-
-  file  = pfilename
+  file = nc_name
   CALL flio_dom_file (file,domain_id)
 !-
-  iret = NF90_CREATE (file,NF90_CLOBBER,ncid)
-!-
-  iret = NF90_DEF_DIM (ncid,'x',pim,xid(nb_files))
-  yid(nb_files) = 0
+! Check the mode
+!? See fliocom for HDF4 ????????????????????????????????????????????????
+!-
+  IF (PRESENT(mode)) THEN
+    SELECT CASE (TRIM(mode))
+    CASE('32')
+      m_c = NF90_CLOBBER
+    CASE('64')
+      m_c = IOR(NF90_CLOBBER,NF90_64BIT_OFFSET)
+    CASE DEFAULT
+      CALL ipslerr (3,"histbeg", &
+ &      'Invalid argument mode for file :',TRIM(file), &
+ &      'Supported values are 32 or 64')
+    END SELECT
+  ELSE
+    m_c = IOR(NF90_CLOBBER,NF90_64BIT_OFFSET)
+  ENDIF
+!-
+! Create file
+!-
+  iret = NF90_CREATE(file,m_c,nfid)
+!-
+  IF     (k_typ == 1) THEN
+    iret = NF90_DEF_DIM(nfid,'lon',k_szx,W_F(idf)%xid)
+    iret = NF90_DEF_DIM(nfid,'lat',k_szy,W_F(idf)%yid)
+  ELSEIF (k_typ == 2) THEN
+    iret = NF90_DEF_DIM(nfid,'x',k_szx,W_F(idf)%xid)
+    iret = NF90_DEF_DIM(nfid,'y',k_szy,W_F(idf)%yid)
+  ELSEIF (k_typ == 3) THEN
+    iret = NF90_DEF_DIM(nfid,'x',pim,W_F(idf)%xid)
+    W_F(idf)%yid = W_F(idf)%xid
+  ENDIF
 !-
 ! 4.0 Declaring the geographical coordinates and other attributes
 !-
-  IF (l_dbg) WRITE(*,*) "histbeg_irregular 4.0"
-!-
-! 4.3 Global attributes
-!-
-  iret = NF90_PUT_ATT (ncid,NF90_GLOBAL,'Conventions','CF-1.1')
-  iret = NF90_PUT_ATT (ncid,NF90_GLOBAL,'file_name',TRIM(file))
-  iret = NF90_PUT_ATT (ncid,NF90_GLOBAL,'production',TRIM(model_name))
+  IF (l_dbg) WRITE(*,*) c_nam//" 4.0"
+!-
+  iret = NF90_PUT_ATT(nfid,NF90_GLOBAL,'Conventions','CF-1.1')
+  iret = NF90_PUT_ATT(nfid,NF90_GLOBAL,'file_name',TRIM(file))
+  iret = NF90_PUT_ATT(nfid,NF90_GLOBAL,'production',TRIM(model_name))
   lock_modname = .TRUE.
   CALL ioget_timestamp (timenow)
-  iret = NF90_PUT_ATT (ncid,NF90_GLOBAL,'TimeStamp',TRIM(timenow))
+  iret = NF90_PUT_ATT(nfid,NF90_GLOBAL,'TimeStamp',TRIM(timenow))
 !-
 ! 5.0 Saving some important information on this file in the common
 !-
-  IF (l_dbg) WRITE(*,*) "histbeg_irregular 5.0"
+  IF (l_dbg) WRITE(*,*) c_nam//" 5.0"
 !-
   IF (PRESENT(domain_id)) THEN
-    dom_id_svg(pfileid) = domain_id
-  ENDIF
-  ncdf_ids(pfileid) = ncid
-  full_size(pfileid,1:2) = (/ pim,1 /)
+    W_F(idf)%dom_id_svg = domain_id
+  ENDIF
+  W_F(idf)%ncfid = nfid
+  IF ( (k_typ == 1).OR.(k_typ == 2) ) THEN
+    W_F(idf)%full_size(1:2) = (/ pim,pjm /)
+    W_F(idf)%regular=.TRUE.
+  ELSEIF (k_typ == 3) THEN
+    W_F(idf)%full_size(1:2) = (/ pim,1 /)
+    W_F(idf)%regular=.FALSE.
+  ENDIF
 !-
 ! 6.0 storing the geographical coordinates
 !-
-  zoom(pfileid)=.FALSE.
-  regular(pfileid)=.FALSE.
-!-
-  CALL histhori_irregular &
- &  (pfileid,pim,plon,plon_bounds,plat,plat_bounds, &
- &   ' ' ,'Default grid',phoriid)
-!-------------------------------
-END SUBROUTINE histbeg_irregular
+  IF     (k_typ == 1) THEN
+    CALL histh_all &
+ &   (k_typ,idf,pim,pjm,' ','Default grid',phoriid, &
+ &    x_1d=x_1d,y_1d=y_1d)
+  ELSEIF (k_typ == 2) THEN
+    CALL histh_all &
+ &   (k_typ,idf,pim,pjm,' ','Default grid',phoriid, &
+ &    x_2d=x_2d,y_2d=y_2d)
+  ELSEIF (k_typ == 3) THEN
+    CALL histh_all &
+ &   (k_typ,idf,pim,pim,' ','Default grid',phoriid, &
+ &    x_1d=x_1d,y_1d=y_1d,x_bnds=x_bnds,y_bnds=y_bnds)
+  ENDIF
+!-----------------------
+END SUBROUTINE histb_all
 !===
-SUBROUTINE histhori_regular &
- &  (pfileid,pim,plon,pjm,plat,phname,phtitle,phid,opt_rectilinear)
-!---------------------------------------------------------------------
-!- This subroutine is made to declare a new horizontale grid.
+SUBROUTINE histh_reg1d &
+ &  (idf,pim,plon,pjm,plat,phname,phtitle,phid)
+!---------------------------------------------------------------------
+!- histhori for 1d regular grid (see histh_all)
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  INTEGER,INTENT(IN) :: idf,pim,pjm
+  REAL,INTENT(IN),DIMENSION(:) :: plon,plat
+  CHARACTER(LEN=*),INTENT(IN) :: phname,phtitle
+  INTEGER,INTENT(OUT) :: phid
+!---------------------------------------------------------------------
+  CALL histh_all &
+ & (1,idf,pim,pjm,phname,phtitle,phid,x_1d=plon,y_1d=plat)
+!-------------------------
+END SUBROUTINE histh_reg1d
+!===
+SUBROUTINE histh_reg2d &
+ & (idf,pim,plon,pjm,plat,phname,phtitle,phid)
+!---------------------------------------------------------------------
+!- histhori for 2d regular grid (see histh_all)
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  INTEGER,INTENT(IN) :: idf,pim,pjm
+  REAL,INTENT(IN),DIMENSION(:,:) :: plon,plat
+  CHARACTER(LEN=*),INTENT(IN) :: phname,phtitle
+  INTEGER,INTENT(OUT) :: phid
+!---------------------------------------------------------------------
+  CALL histh_all &
+ & (2,idf,pim,pjm,phname,phtitle,phid,x_2d=plon,y_2d=plat)
+!-------------------------
+END SUBROUTINE histh_reg2d
+!===
+SUBROUTINE histh_irreg &
+ & (idf,pim,plon,plon_bounds,plat,plat_bounds,phname,phtitle,phid)
+!---------------------------------------------------------------------
+!- histhori for irregular grid (see histh_all)
+!---------------------------------------------------------------------
+  IMPLICIT NONE
+!-
+  INTEGER,INTENT(IN) :: idf,pim
+  REAL,DIMENSION(:),INTENT(IN) :: plon,plat
+  REAL,DIMENSION(:,:),INTENT(IN) :: plon_bounds,plat_bounds
+  CHARACTER(LEN=*),INTENT(IN) :: phname,phtitle
+  INTEGER,INTENT(OUT) :: phid
+!---------------------------------------------------------------------
+  CALL histh_all &
+ & (3,idf,pim,pim,phname,phtitle,phid, &
+ &  x_1d=plon,y_1d=plat,x_bnds=plon_bounds,y_bnds=plat_bounds)
+!-------------------------
+END SUBROUTINE histh_irreg
+!===
+SUBROUTINE histh_all &
+ & (k_typ,idf,pim,pjm,phname,phtitle,phid, &
+ &  x_1d,y_1d,x_2d,y_2d,x_bnds,y_bnds)
+!---------------------------------------------------------------------
+!- General interface for horizontal grids.
+!- This subroutine is made to declare a new horizontal grid.
 !- It has to have the same number of points as
 !- the original and thus in this routine we will only
@@ -572,9 +536,8 @@
 !- INPUT
 !-
-!- pfileid : The id of the file to which the grid should be added
+!- k_typ   : Type of the grid (1 rectilinear, 2 regular, 3 irregular)
+!- idf     : The id of the file to which the grid should be added
 !- pim     : Size in the longitude direction
-!- plon    : The longitudes
-!- pjm     : Size in the latitude direction
-!- plat    : The latitudes
+!- pjm     : Size in the latitude direction (pjm=pim for type 3)
 !- phname  : The name of grid
 !- phtitle : The title of the grid
